/*
 * Funambol is a mobile platform developed by Funambol, Inc. 
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 * 
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 * 
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 * 
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#ifndef INCL_CLIENT_PUSH_MANAGER
#define INCL_CLIENT_PUSH_MANAGER

/** @cond DEV */

#include <windows.h>
#include <initguid.h>   
#include <pimstore.h>   
#include <aygshell.h>   
#include <commctrl.h>   
  
#include "spdm/DMTree.h"
#include "spdm/DMTreeFactory.h"
#include "pim/Utils.h"
#include "base/util/utils.h"
#include "processUtils.h"
#include "pim/maincpp.h"

#include <Pmpolicy.h>
#include <Pm.h>
#include <string>
#include <list>

#define g_szClassName       TEXT("ClientPushWindow")

#define CP_LOG_PATH         ""
#define CP_LOG_NAME         "notlstnr.txt"


/**
 * The class to manage the CTP connection, singleton.
 */
class ClientPushManager {


public:

    HINSTANCE                cp_hInstanc;
    HWND                     cp_hWnd;
    WNDCLASS                 cp_wncClass;

    IPOutlookApp2            *g_polApp;
    IPOutlookItemCollection  *g_pCol;
    
    HANDLE cpThread; 

    /// Pointer to CTPManager instance
    static ClientPushManager* pinstance;
    
    bool scheduleActive;

    // Constructor
    ClientPushManager();
    
    // Method to get the sole instance of CTPManager
    static ClientPushManager* getInstance();

    ~ClientPushManager();

    HANDLE startCP(HANDLE m);
    int stopCP();
    int suspendCP(int value = 14);   
    int resumeCP(int value = 14);   
    
    bool stopThread(HANDLE thread, DWORD exitcode = 0);

    HRESULT InitPOOM();
    HRESULT UnInitPOOM();

    int createClientPushClass (WNDCLASS *lpWndClass, HANDLE module);
    HRESULT subscribeToNotifications(IPOutlookApp2 *pPoom, int olItemType, 
        uint uiNotificationsType);
    void setPIMModifications(int olFolderType);
    OlDefaultFolders ItemTypeToFolder(int olItemType);
    
    bool subscribeContact();
    bool subscribeCalendar();
    bool subscribeTask();

    bool unsubscribeContact();
    bool unsubscribeCalendar();
    bool unsubscribeTask();

};


/** @endcond */
#endif

