/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#pragma once

/**
 * default color for the link
 */
#define LINK_COLOR_NORMAL RGB(0,0,255)

class CCustomButton : public CButton
{
	DECLARE_DYNAMIC(CCustomButton)

public:
    CCustomButton();   // standard constructor
    virtual ~CCustomButton();
    /**
     *  link drawing is done here, draws frame around it if it's focused
     */
    void DrawButton(CDC &dc);

    CString getText() const { return text; }
    void setText(CString val) { text = val; }

protected:
    CString text;
    CFont fontLink;

    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    afx_msg void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

  DECLARE_MESSAGE_MAP()
   /**
    *  on paint redraws the button
    */
    afx_msg void OnPaint();

    /**
     * on set focus, repaint the control
     */
    afx_msg void OnSetFocus(CWnd* pOldWnd);

    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

    /**
     *  on changing the enabled state, repaint the control
     */
    afx_msg void OnEnable( BOOL bEnable );

    /**
     * on mouse(stylus) action performed, repaint the control
     */
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnLButtonUp(UINT nFlags,  CPoint point  );

    /**
     * on some special control messages, repaint the control
     */
    afx_msg void OnSettingChange( UINT uFlags,  LPCTSTR lpszSection  );
};


