/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

// notes are not supported on smartphone

#pragma once
#include "afxwin.h"
#include "CustomButton.h"

// CNotesSettings dialog

class CNotesSettings : public CDialog
{
	DECLARE_DYNAMIC(CNotesSettings)

public:
	CNotesSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CNotesSettings();

  #if defined(WIN32_PLATFORM_PSPC)
	// Dialog Data
	enum { IDD = IDD_UI_NOTES };
  #endif

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        SHMENUBARINFO dlgCommandBar;
        CComboBox lstSyncType;
    #endif

	CFont fontBold;

    /**
     * contains the folder (if any) set by OnMenuFolder(), or by default the folder set in the Registry
     */
    CString folder;

    CCustomButton linkAdvanced;
    CCustomButton linkChoose;

	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

public:
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

    afx_msg void OnOK();

    /**
     *  opens dialog for choosing the folder
     */
    afx_msg void OnMenuFolder();

    //afx_msg void OnClickedNotesBrowse();

    /**
    *  user selected the 'Advanced Settings' link
    */
    afx_msg void OnBnClickedNotesLinkAdvanced();

    /**
     * user selected the 'Choose'  link
     */
    afx_msg void OnBnClickedNotesLinkChoose();

    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};

//#endif