/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#include <windows.h>
#include <oleauto.h>
#include "initguid.h"
#include "pimstore.h"
#include <stdio.h>
#include "pim/SettingFunctions.h"
#include "pim/Maincpp.h"
#include "pim/utils.h"
#include "base/util/ArrayList.h"
#include "Winbase.h"
#include "base/util/utils.h"

 #define _SETTINGS_
void setPropertyValue(const wchar_t*  fullContext, const char*  prop, const char*  value);
void settings();

#ifdef _WIN32_WCE
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPWSTR lpCmdLine, int nShowCmd ) {
#else
int main(int argc, char** argv) {
#endif

    //Initialization of registry;
#ifdef _SETTINGS_
    settings();
#endif
#ifndef _SETTINGS_

    wchar_t errormsg[1024];
    synchronize(errormsg, TEXT("\\"), NULL);
    //startSync(NULL);


#endif
    return 0;
 }


void getDeviceInfo() {
    FILE* f = fopen("\\infoDevice.txt", "w+");

    OSVERSIONINFO OSVersionInfo;
    OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&OSVersionInfo);
    wchar_t buffer[200]; wchar_t buffer2[300];
    char tt[200];
    sprintf(tt, "BuildNumber: %li \n",  OSVersionInfo.dwBuildNumber);
    fputs(tt, f);
    sprintf (tt, "MajorVersion: %li \n", OSVersionInfo.dwMajorVersion);
    fputs(tt, f);
    sprintf (tt, "MinorVersion: %li \n", OSVersionInfo.dwMinorVersion);
    fputs(tt, f);
    sprintf (tt, "PlatformId: %li \n",   OSVersionInfo.dwPlatformId);
    fputs(tt, f);
    sprintf (tt, "CSDVersion: %s \n",      OSVersionInfo.szCSDVersion);
    fputs(tt, f);

    SystemParametersInfo(SPI_GETOEMINFO, 199, &buffer, 0);
    wsprintf(buffer2, L"OEM-INFO: %s \n", buffer);
    fputws(buffer2, f);
    SystemParametersInfo(SPI_GETPLATFORMTYPE, 199, &buffer, 0);
    wsprintf(buffer2, L"Platform type: %s \n", buffer);
    fputws(buffer2, f);
    //SystemParametersInfo(SPI_GETPLATFORMVERSION, 199, &buffer, 0);

    fclose(f);
}


void settings() {
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "username",  "demo@funambol.com"                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "password",  "demo"                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "clientNonce", "cGlwcG8="                );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "serverNonce", "VGB8YHQ6U25lWmAuR3Z3bw==");
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "serverID", "funambol"                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "serverPWD", "funambol"                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "isServerAuthRequired",  "F"             );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "clientAuthType",  "syncml:auth-basic"   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Auth"), "serverAuthType", "syncml:auth-basic"    );

setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "syncUrl",  "http://192.168.0.22:2222/funambol/ds");
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "proxyHost",  ""                                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "proxyPort",  ""                                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "useProxy",  ""                                      );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "proxyUsername",  ""                                 );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "proxyPassword",  ""                                 );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "checkConn",  "1"                                    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "responseTimeout",  "0"                              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "readBufferSize",  "4096"                            );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Conn"), "userAgent",   "SPH_USER_AGENT"                      );

setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevInfo"), "devID", "");
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevInfo"), "dsV",  "" );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevInfo"), "man",  "" );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevInfo"), "mod",  "" );

setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "devType",  "workstation");
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "fwv",  ""               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "hwv",  ""               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "swv",  ""               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "oem",  ""               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\DevDetail"), "loSupport",  "1"        );

setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "begin", "0"              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "end",  "0"               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "devInfHash",  "0"        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "firstTimeSyncMode",  "0" );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "logLevel",  "1"          );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "maxObjSize",  "4500000"  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "maxModPerMsg",  "20"     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "maxMsgSize",  "16384"    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "nocSupport",  "1"        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "utc",  "0"               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\syncml\\Ext"), "verDTD",  "1.1"          );


setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "sync",  "none"                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "last",  "0"                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "name",  "contact"                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "type",  "text/x-s4j-sifc"          );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "syncModes",  "slow,two-way,refresh");
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "uri",  "scard"                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "useSIF",  "1"                      );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "encoding",  "b64"                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "schedule",  "0"                    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\contacts"), "encryption",  "0"                  );



setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "sync",  "none"                               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "last",  "0"                                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "name",  "calendar"                              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "type",  "text/x-s4j-sife"                       );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "syncModes",  "slow,two-way,refresh"  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "uri",  "scal"                                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "useSIF",  "1"                                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "encoding", "b64"                                );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "schedule", "0"                                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\appointments"), "encryption", "0"                                );



setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "sync", "none"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "last", "0"                                            );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "name", "task"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "type", "text/x-s4j-sift"                              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "syncModes",  "slow,two-way,refresh"                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "uri",  "stask"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "useSIF",  "1"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "encoding", "b64"                                      );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "schedule", "0"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\tasks"), "encryption", "0"                                      );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "sync",  "none"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "last",  "0"                                           );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "name",  "note"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "type",  "text/x-s4j-sifn"                             );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "syncModes", "slow,two-way,refresh"                    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "uri",  "snote"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "useSIF",  "1"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "schedule",  "0"                                       );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\notes"), "encryption",  "0"                                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "sync",  "none"                                    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "last",  "0"                                       );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "name",  "briefcase"                               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "type",  "application/*"                           );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "syncModes",  "slow,two-way,refresh"               );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "uri",  "briefcase"                                );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "encoding",  "bin"                                 );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "dir",  "\\"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "schedule",  "0"                                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"), "encryption",  "0"                                 );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "sync", "two-way"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "last", "0"                                            );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "name", "mail"                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "type", "application/vnd.omads-email+xml"              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "syncModes",  "slow,two-way,refresh"                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "uri", "mail"                              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "useSIF",  "0"                              );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "encoding",  "bin"                   );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "Inbox", "1"                                           );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "Outbox", "1"                                          );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "Trash", "0"                                           );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "Sent", "1"                                            );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "Draft",  "0"                                          );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "attachSize",  "-1"                                    );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "bodySize",  "-1"                                       );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "downloadAge",  "-1"                                  );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "schedule",  "0"                                       );
setPropertyValue(TEXT("SOFTWARE\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "mailMaxMsgSize", "2621440"                             );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM\\spds\\sources\\mails"), "encryption",  "0"                                     );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "svrNotified",  "0"                                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "polling",  "0"                                                            );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "pushPort",  "745"                                                         );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "sms", "0"                                                                 );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "push", "0"                                                                );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "path", "\\\\Program Files\\\\Funambol"                                        );
setPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), "sourcesForSlow",  ""                                                      );

}




void setPropertyValue(const wchar_t*  fullContext, const char*  prop, const char*  value) {
    if ((prop == NULL) || (value == NULL)) {
        return;
    }

    HKEY key;
    DWORD res;
    TCHAR *p = NULL;
    TCHAR *v = NULL;

    RegCreateKeyEx(
            HKEY_LOCAL_MACHINE,
            fullContext,
            0,
            NULL,
            REG_OPTION_NON_VOLATILE,
            KEY_ALL_ACCESS,
            NULL,
            &key,
            &res
            );


    if (key == 0) {
        lastErrorCode = ERR_INVALID_CONTEXT;
        sprintf(lastErrorMsg, T("Invalid context path: %s"), fullContext);
        goto finally;
    }

    p = toWideChar(prop);
    v = toWideChar(value);

    RegSetValueEx(
            key,
            p,
            NULL,
            REG_SZ,  // we currently support only strings
            (UCHAR*)v,
            (wcslen(v)+1)*sizeof(WCHAR)
            );

    delete [] p;
    delete [] v;

finally:

    if (key != 0) {
        RegCloseKey(key);
    }
}
