/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
#include "pim/NoteSyncSource.h"
#include "spds/SyncItemStatus.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "pim/FILEClient2Server.h"
#include "pim/FILEServer2Client.h"
#include "pim/SettingFunctions.h"
#include "pim/Utils.h"

NoteSyncSource::NoteSyncSource(const wchar_t* name, SourceType t, SyncSourceConfig* sc) : FileObjectSyncSource(name, sc) {
    dir = NULL;
    setSourceType(t);
    }

NoteSyncSource::~NoteSyncSource() {
}

void NoteSyncSource::setSourceType(SourceType t) {
    setType(t);
}

/*
* retrieves the dir parameter set by user in which there are the notes to sync

void NoteSyncSource::setDirFromDM() {
    wchar_t dir[128];
    memset(dir, 0, 128*sizeof(wchar_t));
    getSourceParameter (SYNC_NOTES, PROPERTY_SOURCE_SPDM_DIR, dir);

    // the getSourceParameter introduce a \0 at the end of the dir array
    // it is necessary for the vb program
    //
    // to avoid it for c program the last char is dropped (the last is ' ' char)

    dir[wcslen(dir) -1] = 0;


    setDir(dir);

}
*/
ArrayElement* NoteSyncSource::clone() {
    NoteSyncSource* s = new NoteSyncSource(getName(), getType(), &(getConfig()));
    s->setPath(getPath());
    s->setDir(getDir());

    s->assign(*this);

    return s;
}