/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#include "event/SyncSourceListener.h"
#include "event/SyncSourceEvent.h"
#include "event/constants.h"
#include "event/ManageListener.h"
#include "events/SyncSourceListenerClient.h"

#include "event/SyncEvent.h"
#include "HwndFunctions.h"

SyncSourceListenerClient::SyncSourceListenerClient() : SyncSourceListener()
{
    sc = 0;
}

void SyncSourceListenerClient::syncSourceBegin(SyncSourceEvent &event) {
    HWND wnd = HwndFunctions::getWindowHandle();
    if(wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_STARTING_SOURCE, NULL, sourceNameToId(event.getSourceName()));
}

void SyncSourceListenerClient::syncSourceEnd(SyncSourceEvent &event)
{
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ENDING_SOURCE, NULL, NULL);
}

void SyncSourceListenerClient::syncSourceSyncModeRequested(SyncSourceEvent &event) {
    wchar_t* t = toWideChar(event.getSourceName());
    setSyncMode(t, event.getSyncMode());
    delete [] t; t = NULL;
}

void SyncSourceListenerClient::setSyncMode(wstring sourcename, long mode) {

    sc->sourcenames.push_back(sourcename);
    sc->modes.push_back(mode);
}

void SyncSourceListenerClient::syncSourceTotalClientItems  (SyncSourceEvent& event) {
}

void SyncSourceListenerClient::syncSourceTotalServerItems  (SyncSourceEvent& event) {
    int source = sourceNameToId(event.getSourceName());

    if(source != -1)
    {
        // send the total number of server items to sync
        if(HwndFunctions::wnd)
            SendMessage(HwndFunctions::wnd, ID_MYMSG_TOTAL_ITEMS,(WPARAM) source,(LPARAM) event.getData());
    }

}
