/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#include "pim/mail/MailItem.h"

//-------------------------------------------------------------- Contructors
MailItem::MailItem() {
    id = 0;
    read = FALSE;
    folder = 0;
}

MailItem::MailItem(MailItem & other) {
    id = stringdup(other.id);
    read = other.read;
    folder = stringdup(other.folder);
}

MailItem::~MailItem() {
    if (id) {
        delete [] id; id = NULL;
    }
    //safeDelete(&id);
    safeDelete(&folder);
}

//----------------------------------------------------------- Accessor methods
void MailItem::setId(const char* t) {
    safeDelete(&id);
    id = stringdup(t);
}

const char* MailItem::getId() {
    return id;
}

void MailItem::setRead(const char* t) {
    if( strcmp(t, "0") == 0 )
        read = false;
    else
        read = true;
}

void MailItem::setRead(bool t) {
    read = t;
}

bool MailItem::getRead() {
    return read;
}

void MailItem::setFolder(const char* t) {
    safeDelete(&folder);
    folder = stringdup(t);
}

const char* MailItem::getFolder() {
    return folder;
}

MailItem & MailItem::operator=(MailItem & other) {
    if(this != &other) {
        setId(other.id);
        setRead(other.read);
        setFolder(other.folder);
    }
    return *this;
}

ArrayElement* MailItem::clone() {
    //MailItem* ret = new MailItem(*this);
    MailItem* ret = new MailItem();
    ret->setId(this->getId());
    ret->setFolder(this->getId());
    ret->setRead(this->getRead());
    return ret;
}
