/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#ifndef INCL_HWND_FUNCTIONS
#define INCL_HWND_FUNCTIONS

#include "windows.h"

#define ID_MYMSG_CONNECTING (WM_APP+1)
#define ID_MYMSG_ENDING (WM_APP+2)
#define ID_MYMSG_STARTSYNC_ENDED (WM_APP+3)
#define ID_MYMSG_STARTING_SYNC (WM_APP+4)
#define ID_MYMSG_ENDING_SOURCE (WM_APP+5)
#define ID_MYMSG_STARTING_SOURCE (WM_APP+6)
#define ID_MYMSG_ITEM_SYNCED_FROM_SERVER (WM_APP+7)
#define ID_MYMSG_TOTAL_ITEMS (WM_APP+8)
#define ID_MYMSG_ITEM_SYNCED_FROM_CLIENT (WM_APP+9)
#define ID_MYMSG_SOURCE_STATE (WM_APP+10)

#define SYNCSOURCE_STATE_OK                 1
#define SYNCSOURCE_STATE_NOT_SYNCED         2
#define SYNCSOURCE_STATE_CANCELED           3

#define SOURCE_MAIL 0
#define SOURCE_CONTACTS 1
#define SOURCE_CALENDAR 2
#define SOURCE_TASKS 3
#define SOURCE_BRIEFCASE 5
#define SOURCE_NOTES 4


class HwndFunctions
{
    public:
        // FIXME: make them private!
      static HWND wnd;
      static HWND wndMsgBox;
      //static HWND wndAccountWindow;

      static void findFunambolWindow();
      static void initHwnd();
      static HWND getWindowHandle();
      //static HWND getAccountWindowHandle();
      static void closePreviousMsgBox();
};

int sourceNameToId(const char* sourceName);
const char* sourceIdToName(const char* sourceName);

#endif