/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

/***********************************************************************
 * Email account handling functions
 ***********************************************************************/

#include <windows.h>
#include <stdio.h>
#include <cfgmgrapi.h>
#include <mapidefs.h>
#include <mapicode.h>
#include <mapitags.h>
#include <mapix.h>
#include <mapiutil.h>
#include <cemapi.h>

#define ACCOUNT_KEY L"F9043C85-F6F2-101A-A3C9-08002B2F49FB"
#define ACCOUNT_PARAM_SIZE  256

/**
 * Modify visible name and email address on Funambol Account
 *
 * @param name - the visible name of the user
 * @param replyAddress - the email address to use for the account
 *
 */
HRESULT modifyAccount(const wchar_t* name, const wchar_t* replyAddress);

/**
 * Get Funambol account information
 *
 * @param name - the visible name of the user
 * @param replyAddress - the email address to use for the account
 *
 */
HRESULT getAccountInfoSession(wchar_t* name, wchar_t* replyaddress, IMAPISession* pSession);

/**
* Get the visible name and the email address of the user of the Funambol
* email account.
*
* @param name - the visible name of the user. OUT
* @param replyaddress - the email address of the user. OUT
*/
HRESULT getAccountInfo(wchar_t* name, wchar_t* replyaddress);

/**
* Return true if the Funambol email account exists
*/
BOOL doesFunambolAccountExist();

/**
* Get the GUID of the Funambol email account
*/
wchar_t* getFunambolGUID(IMAPISession* pSession = NULL);
