/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
#ifndef INCL_MAIL_CLIENT_DATA
#define INCL_MAIL_CLIENT_DATA
/** @cond WMPLUGIN_MAINCLIENT */
/** @{*/

#include "spds/EmailData.h"

/**
* This class represents the mail item inside the cache file that contains the current
* elements into all folder.
*/

class MailClientData {

    private:

        wchar_t* folder;
        wchar_t* entryId;
        EmailData* emailData;
        int maxMailMessageSize;

        // parameter taken from the configuration
        int currentMessageSizeFilter;

        // parameter to understand if the sync is to download the remainig part of the mail
        bool isSyncInclusive;

        // parameter to understand if the attachment are selected in the user filter
        bool includeAttachment;

    public:

        MailClientData(const wchar_t *id);
        ~MailClientData();

        void setEmailData(EmailData* t);
        EmailData* getEmailData() const;

        const wchar_t* getEntryId() const ;

        void setParent(const wchar_t* t);
        void setParent(wchar_t t);
        const wchar_t* getParent() const ;
        void setMaxMailMessageSize(unsigned long v) { maxMailMessageSize = v; }
        unsigned long getMaxMailMessageSize() { return maxMailMessageSize; }

        void setCurrentMessageSizeFilter(unsigned long v) { currentMessageSizeFilter = v; }
        unsigned long getCurrentMessageSizeFilter() { return currentMessageSizeFilter; }

        void setIsSyncInclusive(bool v) { isSyncInclusive = v; }
        bool getIsSyncInclusive() { return isSyncInclusive; }

        void setIncludeAttachment(bool v) { includeAttachment = v; }
        bool getIncludeAttachment() { return includeAttachment; }


};
#endif

