/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2003 - 2007 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#ifndef INCL_MAIL_CONTAINER
#define INCL_MAIL_CONTAINER

#include "base/fscapi.h"
#include "base/util/ArrayList.h"
#include "base/util/ArrayElement.h"
#include "spds/constants.h"
#include "spds/SyncItem.h"

class MailContainer{

private:
    wchar_t* entryID;
    wchar_t* subject;
    wchar_t* body;
    wchar_t* to;
    wchar_t* headers;


    int lenRfc2822;

public:

    /**
     * Constructor: create a MailContainer
     */
    MailContainer();
    ~MailContainer() ;

    void initialize();

    void setEntryID(wchar_t* t);
    wchar_t* getEntryID();

    wchar_t* getSubject();
    void setSubject(wchar_t* t);

    wchar_t* getBody();
    void setBody(wchar_t* t);

    wchar_t* getTo();
    void setTo(wchar_t* t);

    void setHeaders(wchar_t* t);
    wchar_t* getHeaders();

    /*
    * To convert into rfc2822 all the internal properties set into object.
    * It returns a wchar_t created with the new operator and must be descarded by the caller
    */
    wchar_t* toRfc2822();

    /*
    * To convert into object the wchar_t arrived by syncml
    */
    void toMailContainer(wchar_t* t);

    /**
    * gets the len of the rfc2822 transformation.
    */
    int getLenRfc2822();


};

#endif
